﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XDGExpandableFieldRecordStyleCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 1; i <= 10; i++)
            {
                Data.Add(new SampleData()
                {
                    Label = "Label " + i.ToString(),
                    ID = i,
                    Number = r.Next(10000)
                });
            }

            foreach (SampleData SD in Data)
            {
                for (int i = 1; i <= 5; i++)
                {
                    SD.Children1.Add(new ChildData1()
                    {
                        ChildDataLabel1 = "Child1 Label " + i.ToString(),
                        Random1 = r.Next(10000)
                    });                 
                }

                foreach (ChildData1 CD1 in SD.Children1)
                {
                    for (int i = 1; i <= 5; i++)
                    {
                        CD1.Children2.Add(new ChildData2()
                        {
                            ChildDataLabel2 = "Child2 Label " + i.ToString(),
                            Random2 = r.Next(10000)
                        });
                    }
                }

            }
        }
    }

    public class SampleData
    {
        public string Label { get; set; }
        public int ID { get; set; }
        public int Number { get; set; }

        public ObservableCollection<ChildData1> Children1 { get; set; }
        

        public SampleData()
        {
            Children1 = new ObservableCollection<ChildData1>();            
        }
    }

    public class ChildData1
    {
        public string ChildDataLabel1 { get; set; }
        public int Random1 { get; set; }

        public ObservableCollection<ChildData2> Children2 { get; set; }

        public ChildData1()
        {
            Children2 = new ObservableCollection<ChildData2>();
        }
    }

    public class ChildData2
    {
        public string ChildDataLabel2 { get; set; }
        public int Random2 { get; set; }
    }
}
